(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = global || self, factory(global.CommercetoolsSdkMiddlewareCorrelationId = {}));
}(this, function (exports) { 'use strict';

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function createCorrelationIdMiddleware(options) {
    return function (next) {
      return function (request, response) {
        var nextRequest = _objectSpread({}, request, {
          headers: _objectSpread({}, request.headers, {
            'X-Correlation-ID': options.generate()
          })
        });

        next(nextRequest, response);
      };
    };
  }

  // eslint-disable-next-line import/prefer-default-export

  exports.createCorrelationIdMiddleware = createCorrelationIdMiddleware;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=commercetools-sdk-middleware-correlation-id.umd.js.map
